<?php 
	const DB_Name = "wardropes_usw";

	$title = "Fill Person + Shirt Full, in: ".DB_Name; 
?>

<!DOCTYPE html>
<html> 
<head>
	<meta http-equiv="Content-Type" content="text/html; charset=utf8">
	<title><?php echo $title; ?> </title> 
</head>
<STYLE TYPE="text/css">
	body th, td
	{
		font-family:Arial, sans-serif;
	}
</STYLE>
<body>
<?php

	require("functions.php");
	
	// Verbindung zur Datenbank, sie liegt lokalauf dem Rechner, User ist root, Passwort ist nicht definiert, Name der Datenbank ist hier datenbank
	$conn = new mysqli( 'localhost', 'root','', DB_Name );

	if ($conn->connect_error) {
		printf("Verbindungsfehler: %s\n", $conn->connect_error);
		exit();
	}

	const showSQL = 0;
	const Form_Name     = 'FormName';
	const TrennZeichen  = '!';
	// Tasks
	const DEL_Person    = 'D_P_1_';
	const ADD_Person    = 'A_P_2_';
	const DEL_Shirt     = 'D_S_3_';
	const ADD_Shirt     = 'A_S_4_';
	const DEL_War_desc  = 'D_D_5_';
	const ADD_War_desc  = 'A_D_6_';
	const DEL_War_entry = 'D_E_7_';
	const MOV_War_entry = 'A_E_8_';
	const TASK_ID       = 0;
	// Fields	
	const Hidden_Field  = 'Hidden';
	const Submit_Field  = 'SubmitF';
	const New_Name      = 'New_Name';
	const New_Wardrobe  = 'New_Wardrobe';
	const Select_Style  = 'Sel_Style';
	const Select_Color  = 'Sel_Color';
	const Select_Owner  = 'Select_Owner';
	const Select_M_Cont = 'Select_Max_Cont';

	//print_r ($_POST);
	
	if (!sizeof($_POST))
	{
		/*
		  Initial fall. Da das Script noch nicht aufgerufen worden ist, ist noch kein Formular angelegt 
		*/
		
		$TXT = 'Noch nix empfangen!';		
		$OutCounter = 0;		

	}
	else
	{
		/* ----------------------------
		 Hier werden alle TASKs ausgewertet und durchgeführt
		 Dazu wird ein für jedes Kommando zusammengebaut. 
		 Die Tasks-Element werden durch ein Trennzeichen getrennt, so dass mit explode die einzelen Elemente gefunden werden können.
		 Als erstes kommt immer die Task_ID. Je nach Kommando kann es unterschiedliche Argumente geben. 
		 */
		
		if (showSQL) { echo "<br>eingabe: " ; print_r($_POST); }

		$OutCounter = $_POST[Hidden_Field]+1;
		
		//echo '<br>$task raw '.$_POST[Submit_Field];
		$task = explode(TrennZeichen, $_POST[Submit_Field]);
		//echo '<br>$task[0]:>'.$task[0].'< $task[1]:>'.$task[1].'<';
		if ($task[TASK_ID] == DEL_Person)
		{
			// es soll eine Person gelöscht werden
			$sql  = "DELETE FROM PERSON WHERE ID = '".$task[1]."' ";
			$sql_r = $conn->query($sql); 
			if($sql_r === false) trigger_error(_ERROR_TEXT_1.nl2br($sql) . _ERROR_TEXT_1A. $conn->error._ERROR_TEXT_1B, E_USER_ERROR);
			if (showSQL) echo '<br><b>' . ws2html($sql) . '</b><p>';
		}
		elseif ($task[TASK_ID] == DEL_Shirt)
		{
			// es soll ein Shirt gelöscht werden
			
			$conn->begin_transaction();
			
			// in welchem warddropes ist es denn			
			$sql  = "SELECT @WARDROP:=wardrobe_id FROM wardrobes WHERE shirt_id = '".$task[1]."' ";
			$sql_r = $conn->query($sql); 
			if($sql_r === false) trigger_error(_ERROR_TEXT_1.nl2br($sql) . _ERROR_TEXT_1A. $conn->error._ERROR_TEXT_1B, E_USER_ERROR);
			if (showSQL) echo '<br><b>' . ws2html($sql) . '</b><p>';
			
			// es muss vorher aus dem wardrobes gelöscht werden			
			$sql  = "DELETE FROM wardrobes WHERE shirt_id = '".$task[1]."' ";
			$sql_r = $conn->query($sql); 
			if($sql_r === false) trigger_error(_ERROR_TEXT_1.nl2br($sql) . _ERROR_TEXT_1A. $conn->error._ERROR_TEXT_1B, E_USER_ERROR);
			if (showSQL) echo '<br><b>' . ws2html($sql) . '</b><p>';
			
			// bevor das Shirt selber gelöscht gelöscht wird
			$sql  = "DELETE FROM SHIRT WHERE ID = '".$task[1]."' ";
			$sql_r = $conn->query($sql); 
			if($sql_r === false) trigger_error(_ERROR_TEXT_1.nl2br($sql) . _ERROR_TEXT_1A. $conn->error._ERROR_TEXT_1B, E_USER_ERROR);
			if (showSQL) echo '<br><b>' . ws2html($sql) . '</b><p>';
			
			// Dann muss die Anzahl upgedatet werden
			$sql  = "UPDATE wardrobe_desc SET current_content = (SELECT COUNT(SHIRT_ID) FROM wardrobes WHERE wardrobe_id = @WARDROP) WHERE id = @WARDROP ";
			$sql_r = $conn->query($sql); 
			if($sql_r === false) trigger_error(_ERROR_TEXT_1.nl2br($sql) . _ERROR_TEXT_1A. $conn->error._ERROR_TEXT_1B, E_USER_ERROR);
			if (showSQL) echo '<br><b>' . ws2html($sql) . '</b><p>';			
			
			$conn->commit();
			
		}
		elseif ($task[TASK_ID] == DEL_War_desc)
		{
			// es soll ein Wardrope gelöscht werden - geht schief, wenn noch ein Hemd drin ist!!! - ist aber abgefangen, da es dann keinen Button gibt
			$sql  = "DELETE FROM wardrobe_desc WHERE ID = '".$task[1]."' ";
			$sql_r = $conn->query($sql); 
			if($sql_r === false) trigger_error(_ERROR_TEXT_1.nl2br($sql) . _ERROR_TEXT_1A. $conn->error._ERROR_TEXT_1B, E_USER_ERROR);
			if (showSQL) echo '<br><b>' . ws2html($sql) . '</b><p>';
			
		}
		elseif ($task[TASK_ID] == ADD_Person)
		{
			// es soll eine Person zugefügt werden - geht schief, wenn es schon eine soche Person gibt
			$sql  = "INSERT INTO PERSON (Name) VALUES ('".$_POST[New_Name]."'); ";
			$sql_r = $conn->query($sql); 
			if($sql_r === false) trigger_error(_ERROR_TEXT_1.nl2br($sql) . _ERROR_TEXT_1A. $conn->error._ERROR_TEXT_1B, E_USER_ERROR);
			if (showSQL) echo '<br><b>' . ws2html($sql) . '</b><p>';
			
		}
		elseif ($task[TASK_ID] == ADD_Shirt)
		{
			// es soll ein Shirt zugefügt werden - geht schief, wenn es schon eine entsprechendes Shirt gibt
			
			try 
			{

				$MachWeiter = 1;
				$conn->begin_transaction(); 
				$sql  = "INSERT INTO SHIRT (style, Color, Owner) VALUES ('".$_POST[Select_Style]."','".$_POST[Select_Color]."',".$_POST[Select_Owner]."); ";
				$sql_r = $conn->query($sql); 
				if (showSQL) 
					$info_text = 'Exception thrown was: <b>(sql:' . $sql . ',<p><b>Das Shirt konnte nicht zugefügt werden!</b><p>Error: ' . $conn->error .') </b>';
				else
					$info_text = '<p><b>Das Shirt konnte nicht zugefügt werden, weil die UNIQUE-Bedingung verletzt wurde!</b><p>';
				if($sql_r === false) throw new Exception($info_text);
				if (showSQL) echo '<br><b>' . ws2html($sql) . '</b><p>';
			
			}
			catch (Exception $e) 
			{
		 
				// und hier wird die Exception 'aufgefangen'
				if (showSQL)
					echo '<br>Exception was catched!<br>' . $e->getMessage().'<br>No commit has been completed and an rollback has been done!';
				else
					echo $e->getMessage();
				$conn->rollback();
				$MachWeiter = 0;
			}

			
			if ($MachWeiter)
			{
				
				// es scheint so zu sein, dass  LAST_INSERT_ID nach einer beliebigen Query 
				// nicht gültig ist, deshalb wird dieser Wert in einer SQL-Variable gesichert
				$sql  = "SELECT @INIT:=ID, @SHIRT_ID:=LAST_INSERT_ID() FROM wardrobe_desc WHERE initial = 1 ";
				$sql_r = $conn->query($sql); 
				if($sql_r === false) trigger_error(_ERROR_TEXT_1.nl2br($sql) . _ERROR_TEXT_1A. $conn->error._ERROR_TEXT_1B, E_USER_ERROR);
				if (showSQL) echo '<br><b>' . ws2html($sql) . '</b><p>';
				
				$sql  = "INSERT INTO wardrobes (wardrobe_id, Shirt_id) VALUES (@INIT,@SHIRT_ID); ";
				$sql_r = $conn->query($sql); 
				if($sql_r === false) trigger_error(_ERROR_TEXT_1.nl2br($sql) . _ERROR_TEXT_1A. $conn->error._ERROR_TEXT_1B, E_USER_ERROR);
				if (showSQL) echo '<br><b>' . ws2html($sql) . '</b><p>';
			
				$sql  = "UPDATE wardrobe_desc SET current_content = (SELECT COUNT(Shirt_id) FROM wardrobes WHERE wardrobe_id = @INIT) WHERE id = @INIT";
				$sql_r = $conn->query($sql); 
				if($sql_r === false) trigger_error(_ERROR_TEXT_1.nl2br($sql) . _ERROR_TEXT_1A. $conn->error._ERROR_TEXT_1B, E_USER_ERROR);
				if (showSQL) echo '<br><b>' . ws2html($sql) . '</b><p>';			
				
				$conn->commit();
			}

		}
		elseif ($task[TASK_ID] == ADD_War_desc)
		{
			// wie muss die Id des neues Wardropes sein
			$sql  = "SELECT max(id) from wardrobe_desc";
			$sql_r = $conn->query($sql); 
			if($sql_r === false) trigger_error(_ERROR_TEXT_1.nl2br($sql) . _ERROR_TEXT_1A. $conn->error._ERROR_TEXT_1B, E_USER_ERROR);
			if (showSQL) echo '<br><b>' . ws2html($sql) . '</b><p>';
			$sql_row = $sql_r->fetch_array(MYSQLI_NUM); 
			$id = $sql_row[0]+1;
			
			// es soll ein Wardrop zugefügt werden - geht schief, wenn es schon so einen gibt
			$sql  = "INSERT INTO wardrobe_desc (id,max_content, name) VALUES ($id,'".$_POST[Select_M_Cont]."','".$_POST[New_Wardrobe]."'); ";
			$sql_r = $conn->query($sql); 
			if($sql_r === false) trigger_error(_ERROR_TEXT_1.nl2br($sql) . _ERROR_TEXT_1A. $conn->error._ERROR_TEXT_1B, E_USER_ERROR);
			if (showSQL) echo '<br><b>' . ws2html($sql) . '</b><p>';
			
		}
		elseif ($task[TASK_ID] == MOV_War_entry)
		{
			/* 
			   Es sollein Shirt von einem Schrank zum anderen umgehängt werden - 
			   darf nicht sein, wenn der Schrank schon voll ist
			   Parameter
			   $task[1] Shirt_id
			   $task[2] Wardrope_id ziel
			*/
			$conn->begin_transaction(); 
			// es muss zuerst geprüft werden, ob überhaupt noch Platz in dem Wardrope ist
			$id = $task[2];
			$sql  = "SELECT COUNT(SHIRT_ID) AS ANZ \n"
			      . "FROM wardrobes \n"
				  . "WHERE wardrobe_id = ".$id;
			$sql_r = $conn->query($sql); 
			if($sql_r === false) trigger_error(_ERROR_TEXT_1.nl2br($sql) . _ERROR_TEXT_1A. $conn->error._ERROR_TEXT_1B, E_USER_ERROR);
			if (showSQL) echo '<br><b>' . ws2html($sql) . '</b><p>';
			$sql_row = $sql_r->fetch_array(MYSQLI_ASSOC); 
			$anz = $sql_row['ANZ'];
			
			if($sql_r === false) trigger_error(_ERROR_TEXT_1.nl2br($sql) . _ERROR_TEXT_1A. $conn->error._ERROR_TEXT_1B, E_USER_ERROR);
			if (showSQL) echo '<br><b>' . ws2html($sql) . '</b><p>';
			$id = $task[2];
			$sql  = "SELECT max_content AS MAX \n"
			      . "FROM wardrobe_desc  \n"
				  . "WHERE ID = ".$id;
			$sql_r = $conn->query($sql); 
			if($sql_r === false) trigger_error(_ERROR_TEXT_1.nl2br($sql) . _ERROR_TEXT_1A. $conn->error._ERROR_TEXT_1B, E_USER_ERROR);
			if (showSQL) echo '<br><b>' . ws2html($sql) . '</b><p>';
			$sql_row = $sql_r->fetch_array(MYSQLI_ASSOC); 
			$max = $sql_row['MAX'];
			
			if (showSQL) echo '<br>$max:'.$max.' $anz:'.$anz.'<p>';
			if ($anz < $max)
			{
				// wo war das Shirt bisher?
				$sql  = "SELECT @SOURCE:=wardrobe_id FROM wardrobes WHERE Shirt_id = ".$task[1];
				$sql_r = $conn->query($sql); 
				if($sql_r === false) trigger_error(_ERROR_TEXT_1.nl2br($sql) . _ERROR_TEXT_1A. $conn->error._ERROR_TEXT_1B, E_USER_ERROR);
				if (showSQL) echo '<br><b>' . ws2html($sql) . '</b><p>';

				// der Umzug selber
				$sql  = "UPDATE wardrobes SET wardrobe_id = ".$task[2]." WHERE Shirt_id = ".$task[1];
				$sql_r = $conn->query($sql); 
				if($sql_r === false) trigger_error(_ERROR_TEXT_1.nl2br($sql) . _ERROR_TEXT_1A. $conn->error._ERROR_TEXT_1B, E_USER_ERROR);
				if (showSQL) echo '<br><b>' . ws2html($sql) . '</b><p>';

				// im neuen Schrank hochzählen
				$sql  = "UPDATE wardrobe_desc SET current_content = ".$anz." WHERE id = ".$task[2];
				$sql_r = $conn->query($sql); 
				if($sql_r === false) trigger_error(_ERROR_TEXT_1.nl2br($sql) . _ERROR_TEXT_1A. $conn->error._ERROR_TEXT_1B, E_USER_ERROR);
				if (showSQL) echo '<br><b>' . ws2html($sql) . '</b><p>';			
				
				// im alten Schrank herunterzählen - wieviel waren bisher drin
				$sql  = "UPDATE wardrobe_desc SET current_content = (SELECT COUNT(SHIRT_ID) FROM wardrobes WHERE wardrobe_id = @SOURCE) WHERE id = @SOURCE ";
				$sql_r = $conn->query($sql); 
				if($sql_r === false) trigger_error(_ERROR_TEXT_1.nl2br($sql) . _ERROR_TEXT_1A. $conn->error._ERROR_TEXT_1B, E_USER_ERROR);
				if (showSQL) echo '<br><b>' . ws2html($sql) . '</b><p>';			
			}
			else
				echo '<p><b>Der Schrank war bereits voll, das Shirt konnte nicht in den anderen Schrank gebracht werden.</b><p>';
			$conn->commit();
		}
		else
			echo '<p><b>No Task found ('.$task[TASK_ID].')</b>';
		
	}
	echo '<p>Dies ist der '.$OutCounter.' Aufruf von sich selber';
	
	echo '<form action="'.basename(__file__).'" name="'.Form_Name.'" method="POST">';
	echo '<input type="hidden" name="'.Hidden_Field.'" value="'.$OutCounter.'">'; // Hier wird mitgezählt, wie oft er sich selber aufgerufen hat
	
	
	/*
	 --------------------------- Hier werden Personen und Wardrobe-Beschreibungen verwaltet,
	                             D.h. hier werden HTM-Tabellen erzeugt in denen dann Buttons sind, 
								 die Kommandos enthalten - zuerst ist dabei immer die TASK_ID
	*/
	
	// einträge für Personen
	$sql  = "SELECT id, name FROM PERSON ";
	$sql_p = $conn->query($sql); 
	if($sql_p === false) trigger_error(_ERROR_TEXT_1.nl2br($sql) . _ERROR_TEXT_1A. $conn->error._ERROR_TEXT_1B, E_USER_ERROR);
	if (showSQL) echo '<br><b>' . ws2html($sql) . '</b><p>';

	// einträge für Wardrobes
	$sql  = "SELECT initial, id, max_content, current_content, name, ts FROM wardrobe_desc "; 
	$sql_w = $conn->query($sql); 
	if($sql_w === false) trigger_error(_ERROR_TEXT_1.nl2br($sql) . _ERROR_TEXT_1A. $conn->error._ERROR_TEXT_1B, E_USER_ERROR);
	if (showSQL) echo '<br><b>' . ws2html($sql) . '</b><p>';

	// Eine Tabelle mit Personen und Wardrobe-Description
	echo $tab.'<tr><th>Manage Person</th><th>Manage Wardrobe</th></tr>'; // Umschliesst Personen und Schränke in einer Tabelle
	echo '<tr><td>'.$tab.'<tr><th>ID</th><th>Name</th><th>Task</th></tr>';
	for (;$sql_row = $sql_p->fetch_array(MYSQLI_ASSOC);$header = 0) 
	{
		echo '<tr>';
		foreach ($sql_row AS $col)
		{
			
		// die Ergebniszeilen ausgeben
			echo '<td>'.htmlentities ($col, ENT_QUOTES, 'UTF-8').'</td>';
		}
		echo '<td><button type=”submit” name="'.Submit_Field.'" value="'.DEL_Person.TrennZeichen.$sql_row['id'].'" >Delete this Person</button></td>';
		echo '</tr>';
	}
	echo '<tr><td colspan="3">&nbsp;</td></tr>';
	echo '<tr><td>Auto</td>';
	
	// Name der Person
	echo '<td><input type="text" name="'.New_Name.'" value="Replace this Name"/>';	
	echo '<td><button type=”submit” name="'.Submit_Field.'" value="'.ADD_Person.TrennZeichen.'0" >Add this Person</button></td></tr>';

	// abschließen der Personen-Einträge
	echo '</table></td>'; // kein Tabclose, weil dort ein <p> ist 
	
	// einträge für Wardrobes
	echo '<td>'.$tab.'<tr><th>ID</th><th>Max Size</th><th>Current Size</th><th>Name</th><th>TS</th><th>Task</th></tr>';
	for (;$sql_row = $sql_w->fetch_array(MYSQLI_ASSOC);$header = 0) 
	{
		echo '<tr>';
		foreach ($sql_row AS $key => $col)
		{
			
			if ($key == 'initial')
			{
				$init = $col;
				continue;
			}
			// die Ergebniszeilen ausgeben
			echo '<td>'.htmlentities ($col, ENT_QUOTES, 'UTF-8').'</td>';
		}
		if ($init == 0)
		{
			/* 
				hier wird abgefragt, wieviel Shirts in dem Schrank sind. Gibt es welche darf er nicht gelöscht werden
				damit entfällt dann ein Button zum Löschen
				*/
			$sql_c  = "SELECT COUNT(SHIRT_ID) AS ANZ \n"
			        . "FROM wardrobes \n"
				    . "WHERE wardrobe_id = ".$sql_row['id'];
			$sql_r_c = $conn->query($sql_c); 
			if($sql_r_c === false) trigger_error(_ERROR_TEXT_1.nl2br($sql_c) . _ERROR_TEXT_1A. $conn->error._ERROR_TEXT_1B, E_USER_ERROR);
			if (showSQL) echo '<br><b>' . ws2html($sql_c) . '</b><p>';
			$sql_row_c = $sql_r_c->fetch_array(MYSQLI_ASSOC);
			if ($sql_row_c['ANZ'] == 0) // es gibt keine shirts in dem Schrank
				echo '<td><button type=”submit” name="'.Submit_Field.'" value="'.DEL_War_desc.TrennZeichen.$sql_row['id'].'" >Delete this Wardobe</button></td>';
			else
				echo '<td>Enthält '.$sql_row_c['ANZ'].' Shirts</td>';
		}
		else
			echo '<td>&nbsp;</td>';
		echo '</tr>';
	}
	echo '<tr><td colspan="6">&nbsp;</td></tr>';
	echo '<tr><td>Auto</td>';
	
	echo '<td><Select size="3" name="'.Select_M_Cont.'"/>';	
	for ($i=0;$i<7;$i++)
	{
		if ($i == 3)
			echo '<option selected="selected">'.$i.'</option>';
		else
			echo '<option>'.$i.'</option>';
	}
	echo '</Select></td>';
	
	echo '<td>0</td>';
	
	echo '<td><input type="text" name="'.New_Wardrobe.'" value="Replace this Wardrobe"/>';	
	
	echo '<td>&nbsp;</td><td><button type=”submit” name="'.Submit_Field.'" value="'.ADD_War_desc.TrennZeichen.'0" >Add this Wardrobe</button></td></tr>';
	echo '</tr>';
	
	echo '</table>'.$tabClose; // zuerst die Tabelle schließen, mit Personen und Wardrobes

	
	/*
	 
	 --------------------------- Hier werden Shirts und Wardrobe-Entries verwaltet
	
	
	Hier wird die Zuweisung der Shirts zu den Wardrops ausgerechnet und in einer Art Kreuztabelle dargestellt
	So soll die erechnete Query etwa aussehen!
	$sql  = "SELECT shirt_id AS S, Shirt-Infos..., wardrobe_id AS W, \n"
	      . " if (wardrobe_id = 2,'X',Befehl_zum_Übertragen) AS W_1, \n"
	      . " if (wardrobe_id = 3,'X',Befehl_zum_Übertragen) AS W_2, \n"
	      . " if (wardrobe_id = 4,'X',Befehl_zum_Übertragen) AS W_3 \n"
		  . " FROM wardrobes ORDER BY shirt_id ";
		Da zuerst noch nicht bekannt ist, welche Wardrip es gibt, müssen dieser Zuerst ermittelt werden
	
	*/
		  
	// hier werden die Wardropes aufgelistet, auch für die es gerade keinen Inhalt gibt - das Ergebnis steht in $sql_d
	$sql  = "SELECT id AS W, name AS N "
		  . " FROM wardrobe_desc \n"
		  . " ORDER BY id ";
	$sql_d = $conn->query($sql); 
	if($sql_d === false) trigger_error(_ERROR_TEXT_1.nl2br($sql) . _ERROR_TEXT_1A. $conn->error._ERROR_TEXT_1B, E_USER_ERROR);
	if (showSQL) echo '<br><b>' . ws2html($sql) . '</b><p>';

	// hier werden nun die shirts abgefragt, das Ergebnis steht in $sql
	$sql  = "SELECT s.Id, style, color, name AS OwnerName FROM SHIRT AS S \n"
	      . "LEFT JOIN PERSON AS P ON s.owner = p.id ";
	
	const show_IDs_Kreuztabelle = 0; // nur zum Debugging, die Shirt und Wardrop-Id aus der  Kreuztabelle zeigen


	$sql  = "SELECT TS.id AS S, style, color, name AS OwnerName, ";
	if(show_IDs_Kreuztabelle) 
		$sql .= "if(isnull(TW.Shirt_id),0,TW.Shirt_id) AS S0, TW.wardrobe_id AS W, ";
	// da jedes Shirt immer in einem wardrop sein muss und dies in wardrobes steht, kann die Zuweisung shirt->wardrope gefunden werden
	for ($first=1,$col_w=1,$w_name=array();$sql_row = $sql_d->fetch_array(MYSQLI_ASSOC);$col_w++,$first=0)
	{
		if (!$first)
			$sql .= ", \n";
		else
			$sql .= " \n";
		/* 
			Hier wird festgelegt, was in einem Button steht:
			Zusammensetzung: Task ! Shirt_id ! wardrop_id (ziel) ! wardrop_id (quelle)
			Die Task-Id MOV_War_entry wird weiter oben dann ausgewertet
		*/
		$sql .= " if (wardrobe_id = ".$sql_row['W'].",'X',CONCAT('".MOV_War_entry."','".TrennZeichen."',"
		.														 "shirt_id,'".TrennZeichen."',"
		.                                                        $sql_row['W'].",'".TrennZeichen."',"
		.                                                        "wardrobe_id)) AS W_".$col_w;
		$w_name[] = $sql_row['N']; // Liste der Wardope-Namen
	}
	$sql .= "\nFROM Shirt AS TS \n";
	$sql .= "LEFT JOIN PERSON AS TP ON TS.owner = TP.id \n";
	$sql .= "LEFT JOIN wardrobes AS TW ON TS.Id = TW.shirt_id \n";
	$sql .= "ORDER BY TS.id ";
	
	
	$sql_r = $conn->query($sql); 
	if($sql_r === false) trigger_error(_ERROR_TEXT_1.nl2br($sql) . _ERROR_TEXT_1A. $conn->error._ERROR_TEXT_1B, E_USER_ERROR);
	if (showSQL) echo '<br><b>' . ws2html($sql) . '</b><p>';
	if (showSQL) printTable($sql_r,$tab,$tabClose);
	if (showSQL) mysqli_data_seek($sql_r,0); // weil der Ergebniszeiger nach printTable auf dem Ende steht
	
	// Titel die Shirts
	echo $tab.'<tr><th rowspan="2">ID</th><th rowspan="2">Style</th><th rowspan="2">Color</th><th rowspan="2">Owner</th><th rowspan="2">Task</th>';
	// Titel die Wardropbes-Inhalte
	
	// Titel die Wardrobe-Entries
	if(show_IDs_Kreuztabelle) echo '<th colspan="3">&nbsp;</th>'; 
	echo '<th colspan="'.($col_w-1).'">Wardropes</th></tr>';
	echo '<tr>';
	if(show_IDs_Kreuztabelle) 
		echo '<th>Shirt</th><th>S0</th>'; 
	foreach($w_name AS $wn)
		echo '<th>'.$wn.'</th>';
	echo '</tr>';

	
	for (;$sql_row = $sql_r->fetch_array(MYSQLI_ASSOC);$header = 0) 
	{
		echo '<tr>';
		$colNum=0;
		foreach ($sql_row AS $col)
		{
			$colNum++;
			if ($colNum == 5) 
				echo '<td><button type=”submit” name="'.Submit_Field.'" value="'.DEL_Shirt.TrennZeichen.$sql_row['S'].'" >Delete this Shirt</button></td>';
			if ($colNum >= 5 )
			{
				if ($col == 'X')
					echo '<td align="center">X</td>';
				else
					echo '<td align="center"><button type=”submit” name="'.Submit_Field.'" value="'.$col.'" >Move</button></td>';
			}
			else
				echo '<td>'.htmlentities ($col, ENT_QUOTES, 'UTF-8').'</td>';
				
		}
		echo '</tr>';
	}
		
	// Hier kann ein Shirt zugefügt werden
	
	echo '<tr><td colspan="'.($colNum+1).'">&nbsp;</td></tr>';
	echo '<tr><td>Auto</td>';
	
	echo '<td><Select size="3" name="'.Select_Style.'"/>';	
	echo '<option selected="selected">polo</option>';
	echo '<option>dress</option>';
	echo '<option>t-Shirt</option>';
	echo '</Select></td>';
	
	echo '<td><Select size="3" name="'.Select_Color.'"/>';	
	echo '<option selected="selected">red</option>';
	echo '<option>blue</option>';
	echo '<option>orange</option>';
	echo '<option>white</option>';
	echo '<option>black</option>';
	echo '</Select></td>';
	
	echo '<td><Select size="3" name="'.Select_Owner.'"/>';	
	$sql  = "SELECT id, name FROM PERSON ";
	$sql_p1 = $conn->query($sql); 
	if($sql_p1 === false) trigger_error(_ERROR_TEXT_1.nl2br($sql) . _ERROR_TEXT_1A. $conn->error._ERROR_TEXT_1B, E_USER_ERROR);
	for ($selted=1;$sql_row = $sql_p1->fetch_array(MYSQLI_ASSOC);$header = 0) 
	{
		echo '<option value="'.$sql_row[id].'" '.(($selted)?'selected="selected"':'').'>'.$sql_row[name].'</option>';
		$selted=0;
	}
	echo '</Select></td>';
	echo '<td><button type=”submit” name="'.Submit_Field.'" value="'.ADD_Shirt.TrennZeichen.'0" >ADD this Shirt</button></td>';
	
	//Ende des Zufügens eines Shirts
	
	// Die letzte Zeile muss noch ergänzt werden
	
	echo '<td colspan="'.($colNum-4).'">&nbsp;</td><tr>'; 

	echo $tabClose;
	echo '</form>';
	
	// Die Verbindung zur Datenbank wird beendet	
	$conn->close();

?>

 </body>
</html>